/********************************/
/* コインの裏と表をあてるゲーム */
/*    coded by Y.Suganuma       */
/********************************/
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Random;
import java.applet.*;

public class Game extends Applet implements ItemListener, ActionListener {
	int h_te, k0 = -5, m_te, point = 0;
	int kako[] = new int [4];   // ４回前，３回前，前々回，及び前回の入力値
	int table[][] = new int [16][2];   // k （=8*kako[0]+4*kako[1]+2*kako[2]+kako[3]）
                                       // 行目のデータを参照し，もし，table[k][0]>table[k][1]
                                       // なら１を予測値とし，そうでなければ０を予測値とする
	Checkbox c1, c2;
	TextField tx;
	Button bt;
	Scale sc;

	/************/
	/* 初期設定 */
	/************/
	public void init()
	{
		int i1, i2;
					// カラー，レイアウト，フォント
		setLayout(new BorderLayout(5, 10));
		setBackground(new Color(238, 255, 238));
		Font f = new Font("TimesRoman", Font.BOLD, 20);
		setFont(f);
					// メッセージ
		Panel pn1 = new Panel();
		pn1.setLayout(new GridLayout(5, 1));
		add(pn1, BorderLayout.NORTH);
		pn1.add(new Label("コンピュータの考えている数字（0 か 1 ）を当てて下さい"));
		pn1.add(new Label("　　もし当たれば，あなたの得点に 1 点加算されます"));
		pn1.add(new Label("　　はずれると，あなたの得点から 1 点減点されます"));
		pn1.add(new Label("　　得点が 25 点になればあなたの勝ちです"));
		pn1.add(new Label("　　もし，-25 点になるとコンピュータの勝ちになります"));
					// チェックボックスとボタン
		Panel pn2 = new Panel();
		add(pn2, BorderLayout.CENTER);

		c1 = new Checkbox("０", false);
		pn2.add(c1);
		c1.addItemListener(this);

		pn2.add(new Label("　　"));
		c2 = new Checkbox("１", false);
		pn2.add(c2);
		c2.addItemListener(this);

		pn2.add(new Label("　　　"));
		bt = new Button("もう一度");
		bt.setBackground(Color.pink);
		bt.addActionListener(this);
		bt.setEnabled(false);
		pn2.add(bt);
					// メッセージエリア
		Panel pn3 = new Panel();
		add(pn3, BorderLayout.SOUTH);
		pn3.setLayout(new BorderLayout(5, 10));

		sc = new Scale(this);
		sc.setSize(1, 70);
		pn3.add(sc, BorderLayout.CENTER);

		tx = new TextField(20);
		pn3.add(tx, BorderLayout.SOUTH);
					// 初期設定
		for (i1 = 0; i1 < 4; i1++)
			kako[i1] = 0;

		for (i1 = 0; i1 < 16; i1++) {
			for (i2 = 0; i2 < 2; i2++)
				table[i1][i2] = 0;
		}
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(10, 10, 10, 10);
	}

	/****************************/
	/* チェックされたときの処理 */
	/****************************/
	public void itemStateChanged(ItemEvent e)
	{
		int k1;
					// コンピュータの手の決定
		k0 += 1;
		if (k0 < 0 || k0 == 10) {
			if (k0 > 0)
				k0 = 0;
			if (Math.random() > 0.5)
				m_te = 1;
			else
				m_te = 0;
		}
		else {
			k1 = 8 * kako[0] + 4 * kako[1] + 2 * kako[2] + kako[3];
			if (table[k1][0] > table[k1][1])
				m_te = 1;
			else
				m_te = 0;
		}
					// 人間の手の入力
		if (c1.getState() == true) {
			h_te = 0;
			c1.setState(false);
		}
		else {
			c2.setState(false);
			h_te = 1;
		}
					// 勝敗
		if (m_te == h_te) {
			point++;
			tx.setText("あなたの勝ちです！（合計＝" + point + "）");
		}
		else {
			point--;
			tx.setText("あなたの負けです！（合計＝" + point + "）");
		}
					// 再描画
		sc.repaint();
					// 表の修正
		k1 = 8 * kako[0] + 4 * kako[1] + 2 * kako[2] + kako[3];
		if (h_te > 0)
			table[k1][1]++;
		else
			table[k1][0]++;
		kako[0] = kako[1];
		kako[1] = kako[2];
		kako[2] = kako[3];
		kako[3] = h_te;
					// 最終的な勝敗
		if (point <= -25 || point >= 25) {
			c1.setEnabled(false);
			c2.setEnabled(false);
			if (point > 0)
				tx.setText("あなたの勝ちです！！");
			else
				tx.setText("コンピュータの勝ちです！！");
			bt.setEnabled(true);
		}
	}

	/******************************/
	/* ボタンが押されたときの処理 */
	/******************************/
	public void actionPerformed(ActionEvent e)
	{
		int i1, i2;

		k0    = -5;
		point = 0;

		for (i1 = 0; i1 < 4; i1++)
			kako[i1] = 0;

		for (i1 = 0; i1 < 16; i1++) {
			for (i2 = 0; i2 < 2; i2++)
				table[i1][i2] = 0;
		}

		tx.setText("");
		c1.setEnabled(true);
		c2.setEnabled(true);
		bt.setEnabled(false);
		sc.repaint();
	}
}

/******************/
/* スケールを表示 */
/******************/
class Scale extends Canvas {
	Game gm;

	Scale (Game gm_i)
	{
		gm = gm_i;
	}

	public void paint(Graphics g)
	{
		int i1, x;

		g.setColor(Color.black);
		g.drawString("コンピュータ", 10, 20);
		g.drawString("0", 275, 20);
		g.drawString("あなた", 490, 20);
		g.drawLine(30, 50, 530, 50);
		g.drawLine(30, 40, 30, 60);
		g.drawLine(280, 40, 280, 60);
		g.drawLine(530, 40, 530, 60);

		if (gm.point > 0) {
			g.setColor(Color.blue);
			x = 280;
			for (i1 = 0; i1 < gm.point; i1++) {
				g.fillRect(x, 45, 10, 10);
				x += 10;
			}
		}
		else {
			g.setColor(Color.red);
			x = 270;
			for (i1 = 0; i1 < -gm.point; i1++) {
				g.fillRect(x, 45, 10, 10);
				x -= 10;
			}
		}
	}
}
