/********************/
/* クラスDataの定義 */
/********************/
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Random;
import java.applet.*;

public class Data extends Applet implements ItemListener {

	int game = 0;   // ゲームの種類
                    //   =0 : ８パズル
                    //   =1 : １５パズル
	int i_set = 0;   // 初期状態の設定方法
                     //   =0 : 入力する
                     //   =1 : ランダム
	int goal = 0;   // 目標
                    //   =0 : 周辺を回る
                    //   =1 : 上から横並び
	int g[][];   // 目標状態
	int p[][];   // 現在の状態

	Choice choice1, choice2, choice3;
	Data dt = this;

	/************/
	/* 初期設定 */
	/************/
	public void init()
	{
						// レイアウトの変更
		setFont(new Font("TimesRoman", Font.BOLD, 20));
		setLayout(new GridLayout(4, 2, 5, 10));
						// スクロールリスト
		Label fill1 = new Label("ゲーム");
		add(fill1);
		choice1 = new Choice();
		choice1.add("８パズル");
		choice1.add("１５パズル");
		add(choice1);
		choice1.addItemListener(this);

		Label fill2 = new Label("初期設定");
		add(fill2);
		choice2 = new Choice();
		choice2.add("入力");
		choice2.add("ランダム");
		add(choice2);
		choice2.addItemListener(this);

		Label fill3 = new Label("ゴール");
		add(fill3);
		choice3 = new Choice();
		choice3.add("回転");
		choice3.add("横並び");
		add(choice3);
		choice3.addItemListener(this);
						// OK ボタンの設定
		Label fill4 = new Label("　スタート？");
		add(fill4);
		Button bt = new Button("OK");
		bt.addMouseListener(new ClickMouse());
		add(bt);
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(10, 10, 10, 10);
	}

	/******************************/
	/* チョイスコントロールの処理 */
	/******************************/
	public void itemStateChanged(ItemEvent e)
	{
		if (e.getItemSelectable() == choice1) {
			game = ((Choice)e.getItemSelectable()).getSelectedIndex();
		}
		if (e.getItemSelectable() == choice2) {
			i_set = ((Choice)e.getItemSelectable()).getSelectedIndex();
		}
		if (e.getItemSelectable() == choice3) {
			goal = ((Choice)e.getItemSelectable()).getSelectedIndex();
		}
	}

	/********************************/
	/* OKボタンが押されたときの処理 */
	/********************************/
	class ClickMouse extends MouseAdapter
	{
		/************************************/
		/* マウスがクリックされたときの処理 */
		/************************************/
		public void mouseClicked(MouseEvent e)
		{
			int i1, i2, k, k1, k2, n = 0;
		/*
		          ゲームの種類
		*/
							// ８パズル
			if (game == 0) {
				g = new int [3][3];
				p = new int [3][3];
				n = 3;
			}
							// １５パズル
			else {
				g = new int [4][4];
				p = new int [4][4];
				n = 4;
			}
		/*
		          初期状態と目標状態
		*/
					// 初期状態を入力する場合
			Initial initial;
			if (i_set == 0)
				initial = new Initial(dt);
					// 初期状態をランダムに決める場合
						// 目標状態の決定
							// 回転
			else {
				if (goal == 0) {
					if (game == 0) {
						k = 1;
						for (i1 = 0; i1 < n; i1++) {
							g[0][i1] = k;
							k++;
						}
						k = 7;
						for (i1 = 0; i1 < n; i1++) {
							g[2][i1] = k;
							k--;
						}
						g[1][0] = 8;
						g[1][1] = 0;
						g[1][2] = 4;
						k1      = 1;
						k2      = 1;
					}
					else {
						k = 1;
						for (i1 = 0; i1 < n; i1++) {
							g[0][i1] = k;
							g[1][i1] = k + 11;
							k++;
						}
						g[1][3] = 5;
						k       = 10;
						for (i1 = 0; i1 < n; i1++) {
							g[3][i1] = k;
							k--;
						}
						g[2][0] = 11;
						g[2][1] = 0;
						g[2][2] = 15;
						g[2][3] = 6;
						k1      = 2;
						k2      = 1;
					}
				}
							// 横並び
				else {
					k = 1;
					for (i1 = 0; i1 < n; i1++) {
						for (i2 = 0; i2 < n; i2++) {
							g[i1][i2] = k;
							k++;
						}
					}
					g[n-1][n-1] = 0;
					k1          = n - 1;
					k2          = n - 1;
				}
						// 初期状態の決定
				for (i1 = 0; i1 < n; i1++) {
					for (i2 = 0; i2 < n; i2++)
						p[i1][i2] = g[i1][i2];
				}

				for (i1 = 0; i1 < 200; i1++) {
					k = (int)(Math.random() * 4.0);
					switch (k) {
						case 0:   // 上へ移動
							if (k1 > 0) {
								p[k1][k2]   = p[k1-1][k2];
								p[k1-1][k2] = 0;
								k1--;
							}
							break;
						case 1:   // 下へ移動
							if (k1 < n-1) {
								p[k1][k2]   = p[k1+1][k2];
								p[k1+1][k2] = 0;
								k1++;
							}
							break;
						case 2:   // 左へ移動
							if (k2 > 0) {
								p[k1][k2]   = p[k1][k2-1];
								p[k1][k2-1] = 0;
								k2--;
							}
							break;
						default:   // 右へ移動
							if (k2 < n-1) {
								p[k1][k2]   = p[k1][k2+1];
								p[k1][k2+1] = 0;
								k2++;
							}
							break;
					}
				}
						// 目標状態の表示
				Goal goal_s = new Goal(dt);
			}
		}
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}
