/**********************/
/* クラスGoalの定義   */
/* （目標状態の表示） */
/**********************/
import java.io.*;
import java.awt.*;
import java.awt.event.*;

class Goal extends Frame {

	private int size;   // コマの大きさ
	private Data dt;
	private Goal ds = this;
	Insets insets;

	/****************************************/
	/* コンストラクタ                       */
	/*      dt_i : Dataクラスのオブジェクト */
	/****************************************/
	Goal(Data dt_i)
	{
					// Frameクラスのコンストラクタの呼び出し
		super("ゴール");
					// データの設定
		dt   = dt_i;
		size = 50;
		setFont(new Font("TimesRoman", Font.BOLD, 20));
					// Windowの大きさの設定
		if (dt.game == 0)
			setSize(3*(size+10)+70, 3*(size+10)+200);
		else
			setSize(4*(size+10)+70, 4*(size+10)+200);
					// 実行ボタンの設定
		Panel pnl = new Panel();
		Button bt = new Button("ゲームの実行");
		bt.addMouseListener(new ClickMouse());
		pnl.add(bt);
		add("South", pnl);
					// ウィンドウを表示
		setVisible(true);
		insets = getInsets();
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(70, 20, 70, 30);
	}

	/********/
	/* 描画 */
	/********/
	public void paint (Graphics e)
	{
		int i1, i2, x, y;
		int n = (dt.game == 0) ? 3 : 4;
					// 四角形を描く
		x = insets.left + 20;
		y = insets.top;
		e.setColor(Color.cyan);
		for (i1 = 0; i1 < n; i1++) {
			for (i2 = 0; i2 < n; i2++) {
				e.fill3DRect(x, y, size, size, true);
				x += (size + 10);
			}
			x  = insets.left + 20;
			y += (size + 10);
		}
					// 数字を描く
		x = insets.left + 20;
		y = insets.top;
		e.setColor(Color.black);
		e.setFont(new Font("TimesRoman", Font.BOLD, size));
		for (i1 = 0; i1 < n; i1++) {
			for (i2 = 0; i2 < n; i2++) {
				if (dt.g[i1][i2] > 0) {
					if (dt.g[i1][i2] < 10)
						e.drawString(Integer.toString(dt.g[i1][i2]), x+13, y+size-9);
					else
						e.drawString(Integer.toString(dt.g[i1][i2]), x-2, y+size-9);
				}
				x += (size + 10);
			}
			x  = insets.left + 20;
			y += (size + 10);
		}
	}

	/**********************************/
	/* 実行ボタンが押されたときの処理 */
	/**********************************/
	class ClickMouse extends MouseAdapter
	{
		/************************************/
		/* マウスがクリックされたときの処理 */
		/************************************/
		public void mouseClicked(MouseEvent e)
		{
			Run run = new Run(dt);
		}
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			ds.setVisible(false);
		}
	}
}
