/**************************/
/* クラスInitialの定義    */
/* （初期状態の入力）     */
/**************************/
import java.io.*;
import java.awt.*;
import java.awt.event.*;

class Initial extends Frame {

	private int err = 0;   // エラーの有無
	private int n;   // 行・列の数
	private Data dt;
	private Initial in = this;

	TextField a[][];
	Label f[];

	/****************************************/
	/* コンストラクタ                       */
	/*      dt_i : Dataクラスのオブジェクト */
	/****************************************/
	Initial(Data dt_i)
	{
						// Frameクラスのコンストラクタの呼び出し
		super("初期状態");
						// ゲームの種類とレイアウトの変更
		int i1, i2;
		n  = (dt_i.game == 0) ? 3 : 4;
		dt = dt_i;
		a  = new TextField [n][n];
		f  = new Label [n-1];
		setLayout(new GridLayout(n, n+1, 5, 10));
		setFont(new Font("TimesRoman", Font.BOLD, 20));
						// テキストフィールドの設定
		for (i1 = 0; i1 < n; i1++) {
			for (i2 = 0; i2 < n; i2++) {
				a[i1][i2] = new TextField(2);
				add(a[i1][i2]);
			}
			if (i1 < n-1) {
				f[i1] = new Label();
				add(f[i1]);
			}
		}
						// OK ボタンの設定
		Button bt = new Button("OK");
		bt.addMouseListener(new ClickMouse());
		add(bt);
						// Windowサイズを設定
		setSize(200, 300);
						// ウィンドウを表示
		setVisible(true);
						// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(70, 20, 100, 20);
	}

	/**************************/
	/* エラーメッセージの表示 */
	/**************************/
	public void paint(Graphics g)
	{
						// フォントの設定
		Font f = new Font("TimesRoman", Font.BOLD, 20);
		g.setFont(f);
						// エラーメッセージの出力
		Insets insets = getInsets();
		Dimension d = getSize();
		int x = insets.left + 20;
		int y = d.height - insets.bottom + 25;
		if (err == 0)
			g.drawString("             ", x, y);
		else {
			g.setColor(Color.red);
			g.drawString("*** Error ***", x, y);
			g.setColor(Color.black);
		}
	}

	/********************************/
	/* OKボタンが押されたときの処理 */
	/********************************/
	class ClickMouse extends MouseAdapter
	{
		/************************************/
		/* マウスがクリックされたときの処理 */
		/************************************/
		public void mouseClicked(MouseEvent e)
		{
			int i1, i2, i3, i4, k, k1;

			err = 0;
		/*
		          入力データの処理
		*/
			for (i1 = 0; i1 < n && err == 0; i1++) {
				for (i2 = 0; i2 < n && err == 0; i2++) {
					if ((a[i1][i2].getText()).length() <= 0)
						dt.p[i1][i2] = 0;
					else
						dt.p[i1][i2] = Integer.parseInt(a[i1][i2].getText());
					k1 = (dt.game == 0) ? 8 : 15;
					if (dt.p[i1][i2] < 0 || dt.p[i1][i2] > k1)
						err = 1;
					else {
						for (i3 = 0; i3 <= i1 && err == 0; i3++) {
							k1 = (i3 == i1) ? i2 : n;
							for (i4 = 0; i4 < k1 && err == 0; i4++) {
								if (dt.p[i1][i2] == dt.p[i3][i4])
									err = 1;
							}
						}
					}
				}
			}
		/*
		          目標状態
		*/
			repaint();

			if (err == 0) {
							// 回転
				if (dt.goal == 0) {
					if (dt.game == 0) {
						k = 1;
						for (i1 = 0; i1 < n; i1++) {
							dt.g[0][i1] = k;
							k++;
						}
						k = 7;
						for (i1 = 0; i1 < n; i1++) {
							dt.g[2][i1] = k;
							k--;
						}
						dt.g[1][0] = 8;
						dt.g[1][1] = 0;
						dt.g[1][2] = 4;
					}
					else {
						k = 1;
						for (i1 = 0; i1 < n; i1++) {
							dt.g[0][i1] = k;
							dt.g[1][i1] = k + 11;
							k++;
						}
						dt.g[1][3] = 5;
						k          = 10;
						for (i1 = 0; i1 < n; i1++) {
							dt.g[3][i1] = k;
							k--;
						}
						dt.g[2][0] = 11;
						dt.g[2][1] = 0;
						dt.g[2][2] = 15;
						dt.g[2][3] = 6;
					}
				}
							// 横並び
				else {
					k = 1;
					for (i1 = 0; i1 < n; i1++) {
						for (i2 = 0; i2 < n; i2++) {
							dt.g[i1][i2] = k;
							k++;
						}
					}
					dt.g[n-1][n-1] = 0;
				}
							// 目標状態の表示
				in.setVisible(false);
				Goal goal_s = new Goal(dt);
			}
		}
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			in.setVisible(false);
		}
	}
}
