/************************/
/* クラスEightの定義    */
/* （問題を解く）       */
/************************/
import java.io.*;
import java.awt.*;
import java.awt.event.*;

class Eight extends Frame {

	private S_Data dt;
	private Eight et = this;
	private TextArea text;

	/******************************************/
	/* コンストラクタ                         */
	/*      dt_i : S_Dataクラスのオブジェクト */
	/******************************************/
	Eight(S_Data dt_i)
	{
						// Frameクラスのコンストラクタの呼び出し
		super("８パズル");
						// レイアウトの変更
		setLayout(new GridLayout(1, 1));
						// テキストフィールドの設定
		setFont(new Font("TimesRoman", Font.BOLD, 20));
		dt   = dt_i;
		text = new TextArea("", 10, 55);
		add(text);
						// Windowサイズを設定
		setSize(450, 450);
						// ウィンドウを表示
		setVisible(true);
						// イベントアダプタ
		addWindowListener(new WinEnd());
						// 実行
		solve();
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(70, 20, 70, 20);
	}

	/********************/
	/* ８－パズルを解く */
	/********************/
	public void solve()
	{
		int i1, i2, i3, pt = 0, rl = 0, sw = 0;
		int ptn[][] = new int [3][3];
		int ptn1[][] = new int [3][3];
		int rl1[] = new int [1];
		double pf, pf1;
	/*
	          問題解決
	*/
		while (sw == 0) {
						// 規則の探索
			pf = 99999.0;
			for (i1 = 0; i1 <= dt.n_o_pattern; i1++) {
				if (dt.tenkai[i1] == 0) {
					pf1 = fire(i1, rl1, ptn1);   // 適用規則と評価関数の計算
					if (pf1 > 10000.0)
						dt.tenkai[i1] = 1;
					else {
						if (pf1 < pf) {           // 最小評価関数規則の選択 */
							pf = pf1;                      // 評価関数値
							pt = i1;                       // 展開パターン
							rl = rl1[0];                   // 適用規則
							for (i2 = 0; i2 < 3; i2++) {   // 規則適用後のパターン
								for (i3 = 0; i3 < 3; i3++)
									ptn[i2][i3] = ptn1[i2][i3];
							}
						}
					}
				}
			}
						// 適用可能規則なし
			if (pf > 10000.0) {
				sw = 1;
				text.insert("解決できませんでした！\n", 0);
			}
						// 規則の適用
			else {

				dt.n_o_pattern += 1;
							// 制限回数超過
				if (dt.n_o_pattern >= dt.MAX) {
					sw = 1;
					text.insert("解決できませんでした！\n", 0);
				}
							// 制限回数以内
				else {

					dt.oya[dt.n_o_pattern]       = pt;
					dt.hukasa[dt.n_o_pattern][0] = dt.hukasa[pt][0] + 1.0;
					dt.hukasa[dt.n_o_pattern][1] = pf;
					dt.tenkai[dt.n_o_pattern]    = 0;

					for (i1 = 0; i1 < 4; i1++)
						dt.kodomo[dt.n_o_pattern][0][i1] = 0;

					for (i1 = 0; i1 < 3; i1++) {
						for (i2 = 0; i2 < 3; i2++)
							dt.pattern[dt.n_o_pattern][i1][i2] = ptn[i1][i2];
					}

					sw = 1;
					for (i1 = 0; i1 < 4 && sw > 0; i1++) {
						if (dt.kodomo[pt][0][i1] == 0) {
							sw                   = 0;
							dt.kodomo[pt][0][i1] = rl;
							dt.kodomo[pt][1][i1] = dt.n_o_pattern;
						}
					}
								// 目標達成のチェック
					sw = 1;
					for (i1 = 0; i1 < 3 && sw > 0; i1++) {
						for (i2 = 0; i2 < 3 && sw > 0; i2++) {
							if (ptn[i1][i2] != dt.g[i1][i2])
								sw = 0;
						}
					}
								// 目標達成
					if (sw > 0) {
						pt = dt.n_o_pattern;
						text.insert("成功！！\n", 0);
						while (pt > 0) {
							p_pattern(pt);
							pt = dt.oya[pt];
						}
						p_pattern(0);
					}
				}
			}
		}
	}

	/*****************************************/
	/* 適用可能な規則を選ぶ                  */
	/*      pt : パターン番号                */
	/*      rl : 適用規則番号                */
	/*      ptn[i][j] : 規則適用後のパターン */
	/*      return : 評価関数の値            */
	/* 有効な規則の集合                      */
	/*      13 : IF [0][0]=0 THEN RIGHT      */
	/*      14 : IF [0][0]=0 THEN DOWN       */
	/*      21 : IF [0][1]=0 THEN LEFT       */
	/*      23 : IF [0][1]=0 THEN RIGHT      */
	/*      24 : IF [0][1]=0 THEN DOWN       */
	/*      31 : IF [0][2]=0 THEN LEFT       */
	/*      34 : IF [0][2]=0 THEN DOWN       */
	/*      42 : IF [1][0]=0 THEN UP         */
	/*      43 : IF [1][0]=0 THEN RIGHT      */
	/*      44 : IF [1][0]=0 THEN DOWN       */
	/*      51 : IF [1][1]=0 THEN LEFT       */
	/*      52 : IF [1][1]=0 THEN UP         */
	/*      53 : IF [1][1]=0 THEN RIGHT      */
	/*      54 : IF [1][1]=0 THEN DOWN       */
	/*      61 : IF [1][2]=0 THEN LEFT       */
	/*      62 : IF [1][2]=0 THEN UP         */
	/*      64 : IF [1][2]=0 THEN DOWN       */
	/*      72 : IF [2][0]=0 THEN UP         */
	/*      73 : IF [2][0]=0 THEN RIGHT      */
	/*      81 : IF [2][1]=0 THEN LEFT       */
	/*      82 : IF [2][1]=0 THEN UP         */
	/*      83 : IF [2][1]=0 THEN RIGHT      */
	/*      91 : IF [2][2]=0 THEN LEFT       */
	/*      92 : IF [2][2]=0 THEN UP         */
	/*        最初の数字：空白の位置         */
	/*        次の数字  ：空白を移動する方向 */
	/*****************************************/
	public double fire(int pt, int [] rl,int [][] ptn)
	{
		int i1, i2, i3, i4, k1, sw;
		int ptn1[][] = new int [3][3];
		double pf;
		double pf1[] = new double [1];

		pf = 99999.0;

		for (i1 = 1; i1 <= 9; i1++) {
			for (i2 = 1; i2 <= 4; i2++) {
				k1 = 10 * i1 + i2;
				sw = rule(pt, pf1, k1, ptn1);
				if (sw > 0) {
					if (pf1[0] < pf) {
						pf    = pf1[0];
						rl[0] = k1;
						for (i3 = 0; i3 < 3; i3++) {
							for (i4 = 0; i4 < 3; i4++)
								ptn[i3][i4] = ptn1[i3][i4];
						}
					}
				}
			}
		}

		return pf;
	}

	/**********************************************************/
	/* 規則が適用か否かを調べ、かつ、適用後の評価関数値を計算 */
	/*      pt : パターン番号                                 */
	/*      pf : 評価関数の値                                 */
	/*      rl : 適用規則番号                                 */
	/*      ptn[i][j] : 規則適用後のパターン                  */
	/*      return : =0 : 適用不可能                          */
	/*               =1 : 適用可能                            */
	/**********************************************************/
	public int rule(int pt, double [] pf, int rl, int [][] ptn)
	{
		int i1, i2, i3, k1, k2, k3, sw;
		double pi[] = new double [1];

		sw = 1;
	/*
	          既に適用した規則か否かのチェック
	*/
		for (i1 = 0; i1 < 4 && sw > 0; i1++) {
			if (rl == dt.kodomo[pt][0][i1])
				sw = 0;
		}
	/*
	          物理的適用可能性のチェック
	*/
		if (sw > 0) {
			k1 = rl / 10;
			k2 = rl % 10;
			sw = -1;
			for (i1 = 0; i1 < 3 && sw < 0; i1++) {
				for (i2 = 0; i2 < 3 && sw < 0; i2++) {
					if (dt.pattern[pt][i1][i2] == 0) {
						sw = 1;
						k3 = 3 * i1 + i2 + 1;
						if (k1 != k3)    // 位置が不適当
							sw = 0;
						else {           // 移動方向のチェック
							if (i1 == 0 && k2 == 2)
								sw = 0;
							if (i1 == 2 && k2 == 4)
								sw = 0;
							if (i2 == 0 && k2 == 1)
								sw = 0;
							if (i2 == 2 && k2 == 3)
								sw = 0;
						}
					}
				}
			}
	/*
	          規則の適用
	*/
			if (sw > 0) {
				apply(pt,rl,ptn);
	/*
	          既に展開したパターンに同じものがあるか否かのチェック
	*/
				for (i1 = 0; i1 <= dt.n_o_pattern && sw > 0; i1++) {
					sw = 0;
					for (i2 = 0; i2 < 3 && sw == 0; i2++) {
						for (i3 = 0; i3 < 3 && sw == 0; i3++) {
							if (ptn[i2][i3] != dt.pattern[i1][i2][i3])
								sw = 1;
						}
					}
					if (sw == 0 && dt.s_method == 2) {
						if (dt.hukasa[i1][0] > dt.hukasa[pt][0]+1.0)
							sw = 1;
					}
				}
	/*
	          評価関数の計算
	*/
				if (sw > 0) {
					sw    = cal_pf(pt, pi, ptn);
					pf[0] = pi[0];
				}
			}
		}

		return sw;
	}

	/*****************************************/
	/* 与えられた規則を適用する              */
	/*      pt : パターン番号                */
	/*      rl : 適用規則番号                */
	/*      ptn : 規則適用後のパターン       */
	/*****************************************/
	public void apply(int pt, int rl, int [][] ptn)
	{
		int i1, i2, j1, j2, k1 = 0, k2 = 0, l1, l2;
	/*
	          適用前のパターン
	*/
		for (i1 = 0; i1 < 3; i1++) {
			for (i2 = 0; i2 < 3; i2++)
				ptn[i1][i2] = dt.pattern[pt][i1][i2];
		}
	/*
	          規則適用後のパターン
	*/
		l1 = rl / 10;
		l2 = rl % 10;
						// 適用前の空白の位置
		j1 = (l1 - 1) / 3;
		j2 = (l1 - 1) % 3;
						// 適用後の空白の位置
		switch (l2) {
			case 1 :
				k1 = j1;
				k2 = j2 - 1;
				break;
			case 2 :
				k1 = j1 - 1;
				k2 = j2;
				break;
			case 3 :
				k1 = j1;
				k2 = j2 + 1;
				break;
			case 4 :
				k1 = j1 + 1;
				k2 = j2;
				break;
		}
	/*
	          適用後のパターン
	*/
		ptn[j1][j2] = ptn[k1][k2];
		ptn[k1][k2] = 0;
	}

	/**************************************************************/
	/* 評価関数の値を計算する                                     */
	/*      pt : パターン番号                                     */
	/*      pf : 評価関数の値                                     */
	/*      ptn[i][j] : 規則適用後のパターン(縦型、横型では未使用)*/
	/*      return : =0 : 適用不可能(縦型探索で深さ制限を越えた時 */
	/*               =1 : 適用可能(その他)                        */
	/**************************************************************/
	public int cal_pf(int pt, double [] pf,int [][] ptn)
	{
		int i1, i2, i3, i4, j1, j2, kyori, pos, seq, ssw, sw;

		sw = 1;

		switch (dt.s_method) {
	/*
	          横型探索
	*/
			case 1 :
				pf[0] = dt.hukasa[pt][0];
				break;
	/*
	          縦型探索
	*/
			case 2 :
				if (dt.hukasa[pt][0] < dt.max_depth)
					pf[0] = -dt.hukasa[pt][0];
				else
					sw = 0;
				break;
	/*
	          深さ＋目標状態と異なる位置の数
	*/
			case 3 :
				pos = 0;
				for (i1 = 0; i1 < 3; i1++) {
					for (i2 = 0; i2 < 3; i2++) {
						if (ptn[i1][i2] != 0) {
							if (ptn[i1][i2] != dt.g[i1][i2])
								pos += 1;
						}
					}
				}
				pf[0] = dt.hukasa[pt][0] + (double)pos;
				break;
	/*
	          h(n) = p(n) + 3s(n)
	               p(n) : 目標状態からの距離
	               s(n) : =0 : 次の駒が正しい順序の時(中心の駒を除く)
	                      =2 : 次の駒が誤った順序の時(中心の駒を除く)
	                      =1 : 中心の駒
	*/
			case 4 :
				kyori = 0;
				for (i1 = 0; i1 < 3; i1++) {
					for (i2 = 0; i2 < 3; i2++) {
						if (ptn[i1][i2] != 0) {
								// 距離の計算
							ssw = 0;
							for (i3 = 0; i3 < 3 && ssw == 0; i3++) {
								for (i4 = 0; i4 < 3 && ssw == 0; i4++) {
									if (ptn[i1][i2] == dt.g[i3][i4]) {
										kyori += (Math.abs(i3-i1) + Math.abs(i4-i2));
										ssw    = 1;
									}
								}
							}
								// 次の駒の位置のチェック
							seq = 2;
							if (i1 == 1 && i2 == 1)   // 中心の駒
								seq = 1;
							else {    // 中心以外の駒
								if (i1 == 0) {
									if (i2 == 2) {
										j1 = 1;
										j2 = 2;
									}
									else {
										j1 = i1;
										j2 = i2 + 1;
									}
								}
								else {
									if (i1 == 1) {
										if (i2 == 0) {
											j1 = 0;
											j2 = 0;
										}
										else {
											j1 = 2;
											j2 = 2;
										}
									}
									else {
										if (i2 == 0) {
											j1 = 1;
											j2 = 0;
										}
										else {
											j1 = i1;
											j2 = i2 - 1;
										}
									}
								}
								if (ptn[i1][i2] == 8) {
									if (ptn[j1][j2] == 1)
										seq = 0;
								}
								else {
									if (ptn[j1][j2] == ptn[i1][i2]+1)
										seq = 0;
								}
							}

							kyori += (3 * seq);

						}
					}
				}

				pf[0] = dt.hukasa[pt][0] + (double)kyori;
				break;
	/*
	         その他
	*/
			default :
				pf[0] = dt.hukasa[pt][0];
				break;
		}

		return sw;
	}

	/****************************/
	/* 与えられたパターンの出力 */
	/*      pt : パターン番号   */
	/****************************/
	public void p_pattern(int pt)
	{
		int i1, i2;
		String str;

		for (i1 = 2; i1 >= 0; i1--) {
			str = "   ";
			for (i2 = 0; i2 < 3; i2++)
				str += Integer.toString(dt.pattern[pt][i1][i2]);
			str += "\n";
			text.insert(str, 0);
		}

		str  = "状態番号 ";
		str += Integer.toString(pt);
		str += "  深さ＝ ";
		str += Integer.toString((int)dt.hukasa[pt][0]);
		str += "  評価＝ ";
		str += Integer.toString((int)dt.hukasa[pt][1]);
		text.insert(str + "\n", 0);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			et.setVisible(false);
		}
	}
}
