/**********************/
/* クラスS_Dataの定義 */
/**********************/
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Random;
import java.applet.*;

public class S_Data extends Applet implements ItemListener {

	int MAX = 1000;   // 最大試行回数
	int g[][];   // 目標状態
	int kodomo[][][];   // [i][0][j] : 適用した規則番号
                        // [i][1][j] : 適用後の状態
	int n_o_pattern;   // 展開された状態の数
	int oya[];   // 親の状態番号
	int pattern[][][];   // 現在の状態
	int s_method = 1;   // 探索方法
                        //   =1 : 横型
                        //   =2 : 縦型
                        //   =3 : 深さ＋目標状態と異なるコマの数
                        //   =4 : h(n) = p(n) + 3s(n)
                        //           p(n) : 目標状態からの距離
                        //           s(n) : =0 : 次の駒が正しい順序のとき(中心の駒を除く)
                        //                  =2 : 次の駒が誤った順序のとき(中心の駒を除く)
                        //                  =1 : 中心の駒
	int tenkai[];   // =0 : 未展開（葉）の状態
                    // =1 : 展開済みの状態
	double hukasa[][];   // [i][0] : 状態のの深さ
                         // [i][1] : 評価関数の値
	double max_depth = 10;   // 最大探索深さ

	Choice choice;
	TextField trial, depth;
	S_Data dt = this;

	/************/
	/* 初期設定 */
	/************/
	public void init()
	{
		setFont(new Font("TimesRoman", Font.BOLD, 20));
						// レイアウトの変更
		setLayout(new GridLayout(4, 2, 5, 10));
						// スクロールリスト & テキストフィールド
		Label fill1 = new Label("最大試行回数");
		add(fill1);
		trial = new TextField("1000", 10);
		add(trial);

		Label fill2 = new Label("探索方法");
		add(fill2);
		choice = new Choice();
		choice.add("横型探索");
		choice.add("縦型探索");
		choice.add("評価関数１");
		choice.add("評価関数２");
		add(choice);
		choice.addItemListener(this);

		Label fill3 = new Label("最大探索深さ");
		add(fill3);
		depth = new TextField("10", 10);
		add(depth);
						// OK ボタンの設定
		Label fill4 = new Label("　スタート？");
		add(fill4);
		Button bt = new Button("OK");
		bt.addMouseListener(new ClickMouse());
		add(bt);
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(40, 10, 10, 10);
	}

	/******************************/
	/* チョイスコントロールの処理 */
	/******************************/
	public void itemStateChanged(ItemEvent e)
	{
		if (e.getItemSelectable() == choice) {
			s_method = ((Choice)e.getItemSelectable()).getSelectedIndex() + 1;
		}
	}

	/********************************/
	/* OKボタンが押されたときの処理 */
	/********************************/
	class ClickMouse extends MouseAdapter
	{
		/************************************/
		/* マウスがクリックされたときの処理 */
		/************************************/
		public void mouseClicked(MouseEvent e)
		{
			int i1;
							// 領域の確保
			MAX       = Integer.parseInt(trial.getText());
			max_depth = Integer.parseInt(depth.getText());

			g         = new int [3][3];
			kodomo    = new int [MAX][2][4];
			oya       = new int [MAX];
			pattern   = new int [MAX][3][3];
			tenkai    = new int [MAX];
			hukasa    = new double [MAX][2];
							// 初期設定
			n_o_pattern  = 0;
			hukasa[0][0] = 0.0;
			tenkai[0]    = 0;
			oya[0]       = 0;
			for (i1 = 0; i1 < 4; i1++)
				kodomo[0][0][i1] = 0;
							// ゴールの設定
			g[0][0] = 1;
			g[0][1] = 2;
			g[0][2] = 3;
			g[1][0] = 8;
			g[1][1] = 0;
			g[1][2] = 4;
			g[2][0] = 7;
			g[2][1] = 6;
			g[2][2] = 5;
							// 初期状態の設定
			S_Initial initial = new S_Initial(dt);
		}
	}
}
