/****************************/
/* クラスS_Initialの定義    */
/* （初期状態の入力）       */
/****************************/
import java.io.*;
import java.awt.*;
import java.awt.event.*;

class S_Initial extends Frame {

	private int err = 0;   // エラーの有無
	private int n;   // 行・列の数
	private S_Data dt;
	private S_Initial in = this;

	TextField a[][];
	Label f[];

	/******************************************/
	/* コンストラクタ                         */
	/*      dt_i : S_Dataクラスのオブジェクト */
	/******************************************/
	S_Initial(S_Data dt_i)
	{
						// Frameクラスのコンストラクタの呼び出し
		super("初期状態");
						// レイアウトの変更
		int i1, i2;

		Font fn = new Font("TimesRoman", Font.BOLD, 20);
		n  = 3;
		dt = dt_i;
		a  = new TextField [n][n];
		f  = new Label [n-1];

		setLayout(new GridLayout(n, n+1, 5, 10));
						// テキストフィールドの設定
		for (i1 = 0; i1 < n; i1++) {
			for (i2 = 0; i2 < n; i2++) {
				a[i1][i2] = new TextField(2);
				a[i1][i2].setFont(fn);
				add(a[i1][i2]);
			}
			if (i1 < n-1) {
				f[i1] = new Label();
				add(f[i1]);
			}
		}
						// OK ボタンの設定
		Button bt = new Button("OK");
		bt.setFont(fn);
		bt.addMouseListener(new ClickMouse());
		add(bt);
						// Windowサイズを設定
		setSize(200, 300);
						// ウィンドウを表示
		setVisible(true);
						// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(70, 20, 100, 20);
	}

	/**************************/
	/* エラーメッセージの表示 */
	/**************************/
	public void paint(Graphics g)
	{
						// フォントの設定
		Font f = new Font("TimesRoman", Font.BOLD, 20);
		g.setFont(f);
						// エラーメッセージの出力
		Insets insets = getInsets();
		Dimension d = getSize();
		int x = insets.left + 20;
		int y = d.height - insets.bottom + 25;
		if (err == 0)
			g.drawString("             ", x, y);
		else {
			g.setColor(Color.red);
			g.drawString("*** Error ***", x, y);
			g.setColor(Color.black);
		}
	}

	/********************************/
	/* OKボタンが押されたときの処理 */
	/********************************/
	class ClickMouse extends MouseAdapter
	{
		/************************************/
		/* マウスがクリックされたときの処理 */
		/************************************/
		public void mouseClicked(MouseEvent e)
		{
			int i1, i2, i3, i4, k, k1;

			err = 0;
		/*
		          入力データの処理
		*/
			for (i1 = 0; i1 < n && err == 0; i1++) {
				for (i2 = 0; i2 < n && err == 0; i2++) {
					if ((a[i1][i2].getText()).length() <= 0)
						dt.pattern[0][i1][i2] = 0;
					else
						dt.pattern[0][i1][i2] = Integer.parseInt(a[i1][i2].getText());
					if (dt.pattern[0][i1][i2] < 0 || dt.pattern[0][i1][i2] > 8)
						err = 1;
					else {
						for (i3 = 0; i3 <= i1 && err == 0; i3++) {
							k1 = (i3 == i1) ? i2 : n;
							for (i4 = 0; i4 < k1 && err == 0; i4++) {
								if (dt.pattern[0][i1][i2] == dt.pattern[0][i3][i4])
									err = 1;
							}
						}
					}
				}
			}

			repaint();
							// 解を見つける
			if (err == 0) {
				in.setVisible(false);
				Eight eight = new Eight(dt);
			}
		}
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			in.setVisible(false);
		}
	}
}
